#!/usr/bin/perl

$HTML_TEMPLATE = "/usr/local/apache/htdocs/thesis/index.html";
$INSERT_BEGIN = "<!-- BEGIN SEARCH RESULTS -->";
$INSERT_END = "<!-- END SEARCH RESULTS -->";

###############################################################################
# massage form input
###############################################################################

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

@fm_ary = split(/&/, $buffer);

foreach $fm_item (@fm_ary)
{
	($name, $value) = split(/=/, $fm_item);

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\n/ /g; #Replace newlines with spaces.
	$value =~ s/\r//g;  # Remove hard returns.
	$value =~ s/\cM//g; # Delete ^M's

	$$name = lc($value);
}

###############################################################################
# remove non-alphabetic characters from search string
###############################################################################

$searchstr =~ s/[^a-zA-Z\s]//g;

### remove extra whitespace
$searchstr =~ s/\s+/ /g;

###############################################################################
# Call C++ program with search string as cmd line arg, search for terms
####
# note: should we consider enclosing the command line arguments in double
# quotes?
###############################################################################

@output = `./search "$searchstr"`;

$formatted_output = "";
for(@output)
{
	if(/^http/)
	{
		$formatted_output .= "<a href=\"$_\">$_</a><br />\n";
	}
	else
	{
		$formatted_output .= $_;
	}
}

###############################################################################
# display results.
###############################################################################

$output = "Your search for \"$searchstr\" (all non-alphabet characters were removed) produced the following results:<br /><br />" . $formatted_output;

$output_template = `cat $HTML_TEMPLATE`;
$output_template =~ s/$INSERT_BEGIN(.*)$INSERT_END/$INSERT_BEGIN$output$INSERT_END/si;

print "Content-type:text/html\n\n";
print $output_template;
